/* Plug.c generated by valac 0.46.10, the Vala compiler
 * generated from Plug.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Pantheon Developers (https://launchpad.net/switchboard-plug-printers)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <switchboard.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gmodule.h>

#define PRINTERS_TYPE_PLUG (printers_plug_get_type ())
#define PRINTERS_PLUG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PRINTERS_TYPE_PLUG, PrintersPlug))
#define PRINTERS_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PRINTERS_TYPE_PLUG, PrintersPlugClass))
#define PRINTERS_IS_PLUG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PRINTERS_TYPE_PLUG))
#define PRINTERS_IS_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PRINTERS_TYPE_PLUG))
#define PRINTERS_PLUG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PRINTERS_TYPE_PLUG, PrintersPlugClass))

typedef struct _PrintersPlug PrintersPlug;
typedef struct _PrintersPlugClass PrintersPlugClass;
typedef struct _PrintersPlugPrivate PrintersPlugPrivate;

#define PRINTERS_TYPE_PRINTER_LIST (printers_printer_list_get_type ())
#define PRINTERS_PRINTER_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PRINTERS_TYPE_PRINTER_LIST, PrintersPrinterList))
#define PRINTERS_PRINTER_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PRINTERS_TYPE_PRINTER_LIST, PrintersPrinterListClass))
#define PRINTERS_IS_PRINTER_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PRINTERS_TYPE_PRINTER_LIST))
#define PRINTERS_IS_PRINTER_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PRINTERS_TYPE_PRINTER_LIST))
#define PRINTERS_PRINTER_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PRINTERS_TYPE_PRINTER_LIST, PrintersPrinterListClass))

typedef struct _PrintersPrinterList PrintersPrinterList;
typedef struct _PrintersPrinterListClass PrintersPrinterListClass;
enum  {
	PRINTERS_PLUG_0_PROPERTY,
	PRINTERS_PLUG_NUM_PROPERTIES
};
static GParamSpec* printers_plug_properties[PRINTERS_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PrintersPlugSearchData PrintersPlugSearchData;

struct _PrintersPlug {
	SwitchboardPlug parent_instance;
	PrintersPlugPrivate * priv;
};

struct _PrintersPlugClass {
	SwitchboardPlugClass parent_class;
};

struct _PrintersPlugPrivate {
	GtkPaned* main_paned;
	GtkStack* main_stack;
	PrintersPrinterList* list;
};

struct _PrintersPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PrintersPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* _tmp0_;
};

static gint PrintersPlug_private_offset;
static gpointer printers_plug_parent_class = NULL;

GType printers_plug_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PrintersPlug, g_object_unref)
GType printers_printer_list_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PrintersPrinterList, g_object_unref)
PrintersPlug* printers_plug_new (void);
PrintersPlug* printers_plug_construct (GType object_type);
static GtkWidget* printers_plug_real_get_widget (SwitchboardPlug* base);
PrintersPrinterList* printers_printer_list_new (GtkStack* stack);
PrintersPrinterList* printers_printer_list_construct (GType object_type,
                                                      GtkStack* stack);
static void printers_plug_update_alert_visible (PrintersPlug* self);
static void ___lambda47_ (PrintersPlug* self);
static void ____lambda47__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
gboolean printers_printer_list_get_has_child (PrintersPrinterList* self);
static void printers_plug_real_shown (SwitchboardPlug* base);
static void printers_plug_real_hidden (SwitchboardPlug* base);
static void printers_plug_real_search_callback (SwitchboardPlug* base,
                                         const gchar* location);
static void printers_plug_real_search_data_free (gpointer _data);
static void printers_plug_real_search (SwitchboardPlug* base,
                                const gchar* search,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
static gboolean printers_plug_real_search_co (PrintersPlugSearchData* _data_);
static void printers_plug_finalize (GObject * obj);
SwitchboardPlug* get_plug (GModule* module);

static inline gpointer
printers_plug_get_instance_private (PrintersPlug* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersPlug_private_offset);
}

PrintersPlug*
printers_plug_construct (GType object_type)
{
	PrintersPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	settings = _tmp0_;
	gee_abstract_map_set ((GeeAbstractMap*) settings, "printer", NULL);
	self = (PrintersPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "code-name", "io.elementary.switchboard.printers", "display-name", _ ("Printers"), "description", _ ("Configure printers, manage print queues, and view ink levels"), "icon", "printer", "supported-settings", settings, NULL);
	_g_object_unref0 (settings);
	return self;
}

PrintersPlug*
printers_plug_new (void)
{
	return printers_plug_construct (PRINTERS_TYPE_PLUG);
}

static void
___lambda47_ (PrintersPlug* self)
{
	printers_plug_update_alert_visible (self);
}

static void
____lambda47__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	___lambda47_ ((PrintersPlug*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
printers_plug_real_get_widget (SwitchboardPlug* base)
{
	PrintersPlug * self;
	GtkPaned* _tmp0_;
	GtkPaned* _tmp22_;
	GtkWidget* _tmp23_;
	GtkWidget* result = NULL;
	self = (PrintersPlug*) base;
	_tmp0_ = self->priv->main_paned;
	if (_tmp0_ == NULL) {
		GtkStack* stack = NULL;
		GtkStack* _tmp1_;
		GtkStack* _tmp2_;
		GtkStack* _tmp3_;
		PrintersPrinterList* _tmp4_;
		GraniteWidgetsAlertView* empty_alert = NULL;
		GraniteWidgetsAlertView* _tmp5_;
		GraniteWidgetsAlertView* _tmp6_;
		GraniteWidgetsAlertView* _tmp7_;
		GtkStyleContext* _tmp8_;
		GtkStack* _tmp9_;
		GtkStack* _tmp10_;
		GtkStack* _tmp11_;
		GraniteWidgetsAlertView* _tmp12_;
		GtkStack* _tmp13_;
		GtkStack* _tmp14_;
		GtkPaned* _tmp15_;
		GtkPaned* _tmp16_;
		PrintersPrinterList* _tmp17_;
		GtkPaned* _tmp18_;
		GtkStack* _tmp19_;
		GtkPaned* _tmp20_;
		PrintersPrinterList* _tmp21_;
		_tmp1_ = (GtkStack*) gtk_stack_new ();
		g_object_ref_sink (_tmp1_);
		stack = _tmp1_;
		_tmp2_ = stack;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
		_tmp3_ = stack;
		_tmp4_ = printers_printer_list_new (_tmp3_);
		g_object_ref_sink (_tmp4_);
		_g_object_unref0 (self->priv->list);
		self->priv->list = _tmp4_;
		_tmp5_ = granite_widgets_alert_view_new (_ ("No Printers Available"), _ ("Connect to a printer by clicking the icon in the toolbar below."), "printer-error");
		g_object_ref_sink (_tmp5_);
		empty_alert = _tmp5_;
		_tmp6_ = empty_alert;
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
		_tmp7_ = empty_alert;
		_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
		gtk_style_context_remove_class (_tmp8_, GTK_STYLE_CLASS_VIEW);
		_tmp9_ = (GtkStack*) gtk_stack_new ();
		g_object_ref_sink (_tmp9_);
		_g_object_unref0 (self->priv->main_stack);
		self->priv->main_stack = _tmp9_;
		_tmp10_ = self->priv->main_stack;
		gtk_stack_set_transition_type (_tmp10_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
		_tmp11_ = self->priv->main_stack;
		_tmp12_ = empty_alert;
		gtk_stack_add_named (_tmp11_, (GtkWidget*) _tmp12_, "empty-alert");
		_tmp13_ = self->priv->main_stack;
		_tmp14_ = stack;
		gtk_stack_add_named (_tmp13_, (GtkWidget*) _tmp14_, "main-paned");
		_tmp15_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
		g_object_ref_sink (_tmp15_);
		_g_object_unref0 (self->priv->main_paned);
		self->priv->main_paned = _tmp15_;
		_tmp16_ = self->priv->main_paned;
		_tmp17_ = self->priv->list;
		gtk_paned_pack1 (_tmp16_, (GtkWidget*) _tmp17_, FALSE, FALSE);
		_tmp18_ = self->priv->main_paned;
		_tmp19_ = self->priv->main_stack;
		gtk_paned_pack2 (_tmp18_, (GtkWidget*) _tmp19_, TRUE, FALSE);
		_tmp20_ = self->priv->main_paned;
		gtk_widget_show_all ((GtkWidget*) _tmp20_);
		printers_plug_update_alert_visible (self);
		_tmp21_ = self->priv->list;
		g_signal_connect_object ((GObject*) _tmp21_, "notify::has-child", (GCallback) ____lambda47__g_object_notify, self, 0);
		_g_object_unref0 (empty_alert);
		_g_object_unref0 (stack);
	}
	_tmp22_ = self->priv->main_paned;
	_tmp23_ = _g_object_ref0 ((GtkWidget*) _tmp22_);
	result = _tmp23_;
	return result;
}

static void
printers_plug_update_alert_visible (PrintersPlug* self)
{
	PrintersPrinterList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->list;
	_tmp1_ = printers_printer_list_get_has_child (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkStack* _tmp3_;
		_tmp3_ = self->priv->main_stack;
		gtk_stack_set_visible_child_name (_tmp3_, "main-paned");
	} else {
		GtkStack* _tmp4_;
		_tmp4_ = self->priv->main_stack;
		gtk_stack_set_visible_child_name (_tmp4_, "empty-alert");
	}
}

static void
printers_plug_real_shown (SwitchboardPlug* base)
{
	PrintersPlug * self;
	self = (PrintersPlug*) base;
}

static void
printers_plug_real_hidden (SwitchboardPlug* base)
{
	PrintersPlug * self;
	self = (PrintersPlug*) base;
}

static void
printers_plug_real_search_callback (SwitchboardPlug* base,
                                    const gchar* location)
{
	PrintersPlug * self;
	self = (PrintersPlug*) base;
	g_return_if_fail (location != NULL);
}

static void
printers_plug_real_search_data_free (gpointer _data)
{
	PrintersPlugSearchData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search);
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (PrintersPlugSearchData, _data_);
}

static void
printers_plug_real_search (SwitchboardPlug* base,
                           const gchar* search,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	PrintersPlug * self;
	PrintersPlugSearchData* _data_;
	PrintersPlug* _tmp0_;
	gchar* _tmp1_;
	self = (PrintersPlug*) base;
	_data_ = g_slice_new0 (PrintersPlugSearchData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, printers_plug_real_search_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (search);
	_g_free0 (_data_->search);
	_data_->search = _tmp1_;
	printers_plug_real_search_co (_data_);
}

static GeeTreeMap*
printers_plug_search_finish (SwitchboardPlug* base,
                             GAsyncResult* _res_)
{
	GeeTreeMap* result;
	PrintersPlugSearchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static gboolean
printers_plug_real_search_co (PrintersPlugSearchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	_data_->result = _data_->_tmp0_;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
printers_plug_class_init (PrintersPlugClass * klass,
                          gpointer klass_data)
{
	printers_plug_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PrintersPlug_private_offset);
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) printers_plug_real_get_widget;
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) printers_plug_real_shown;
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) printers_plug_real_hidden;
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) printers_plug_real_search_callback;
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) printers_plug_real_search;
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) printers_plug_search_finish;
	G_OBJECT_CLASS (klass)->finalize = printers_plug_finalize;
}

static void
printers_plug_instance_init (PrintersPlug * self,
                             gpointer klass)
{
	self->priv = printers_plug_get_instance_private (self);
}

static void
printers_plug_finalize (GObject * obj)
{
	PrintersPlug * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_PLUG, PrintersPlug);
	_g_object_unref0 (self->priv->main_paned);
	_g_object_unref0 (self->priv->main_stack);
	_g_object_unref0 (self->priv->list);
	G_OBJECT_CLASS (printers_plug_parent_class)->finalize (obj);
}

GType
printers_plug_get_type (void)
{
	static volatile gsize printers_plug_type_id__volatile = 0;
	if (g_once_init_enter (&printers_plug_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrintersPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersPlug), 0, (GInstanceInitFunc) printers_plug_instance_init, NULL };
		GType printers_plug_type_id;
		printers_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "PrintersPlug", &g_define_type_info, 0);
		PrintersPlug_private_offset = g_type_add_instance_private (printers_plug_type_id, sizeof (PrintersPlugPrivate));
		g_once_init_leave (&printers_plug_type_id__volatile, printers_plug_type_id);
	}
	return printers_plug_type_id__volatile;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	PrintersPlug* plug = NULL;
	PrintersPlug* _tmp0_;
	SwitchboardPlug* result = NULL;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("Plug.vala:104: Activating Printers plug");
	_tmp0_ = printers_plug_new ();
	plug = _tmp0_;
	result = (SwitchboardPlug*) plug;
	return result;
}

