/* CUPSPkHelper.c generated by valac 0.46.10, the Vala compiler
 * generated from CUPSPkHelper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Pantheon Developers (https://launchpad.net/switchboard-plug-printers)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define CUPS_TYPE_PK_HELPER (cups_pk_helper_get_type ())
#define CUPS_PK_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CUPS_TYPE_PK_HELPER, CupsPkHelper))
#define CUPS_IS_PK_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CUPS_TYPE_PK_HELPER))
#define CUPS_PK_HELPER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), CUPS_TYPE_PK_HELPER, CupsPkHelperIface))

typedef struct _CupsPkHelper CupsPkHelper;
typedef struct _CupsPkHelperIface CupsPkHelperIface;

#define CUPS_TYPE_PK_HELPER_PROXY (cups_pk_helper_proxy_get_type ())
typedef GDBusProxy CupsPkHelperProxy;
typedef GDBusProxyClass CupsPkHelperProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _CupsPkHelperDevicesGetReadyData CupsPkHelperDevicesGetReadyData;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _CupsPkHelperIface {
	GTypeInterface parent_iface;
	gchar* (*file_get) (CupsPkHelper* self, const gchar* resource, const gchar* filename, GError** error);
	gchar* (*file_put) (CupsPkHelper* self, const gchar* resource, const gchar* filename, GError** error);
	void (*server_get_settings) (CupsPkHelper* self, gchar* * _error_, GHashTable* * settings, GError** error);
	gchar* (*server_set_settings) (CupsPkHelper* self, GHashTable* settings, GError** error);
	void (*devices_get) (CupsPkHelper* self, gint timeout, gint limit, gchar** include_schemes, gint include_schemes_length1, gchar** exclude_schemes, gint exclude_schemes_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*devices_get_finish) (CupsPkHelper* self, GAsyncResult* _res_, gchar* * _error_, GHashTable* * devices, GError** error);
	gchar* (*printer_add) (CupsPkHelper* self, const gchar* name, const gchar* uri, const gchar* ppd, const gchar* info, const gchar* location, GError** error);
	gchar* (*printer_add_with_ppd_file) (CupsPkHelper* self, const gchar* name, const gchar* uri, const gchar* ppd, const gchar* info, const gchar* location, GError** error);
	gchar* (*printer_set_device) (CupsPkHelper* self, const gchar* name, const gchar* device, GError** error);
	gchar* (*printer_set_default) (CupsPkHelper* self, const gchar* name, GError** error);
	gchar* (*printer_set_enabled) (CupsPkHelper* self, const gchar* name, gboolean enabled, GError** error);
	gchar* (*printer_set_accept_jobs) (CupsPkHelper* self, const gchar* name, gboolean enabled, const gchar* reason, GError** error);
	gchar* (*printer_delete) (CupsPkHelper* self, const gchar* name, GError** error);
	gchar* (*class_add_printer) (CupsPkHelper* self, const gchar* name, const gchar* printer, GError** error);
	gchar* (*class_delete_printer) (CupsPkHelper* self, const gchar* name, const gchar* printer, GError** error);
	gchar* (*class_delete) (CupsPkHelper* self, const gchar* name, GError** error);
	gchar* (*printer_set_info) (CupsPkHelper* self, const gchar* name, const gchar* info, GError** error);
	gchar* (*printer_set_location) (CupsPkHelper* self, const gchar* name, const gchar* location, GError** error);
	gchar* (*printer_set_shared) (CupsPkHelper* self, const gchar* name, gboolean shared, GError** error);
	gchar* (*printer_set_job_sheets) (CupsPkHelper* self, const gchar* name, const gchar* start, const gchar* end, GError** error);
	gchar* (*printer_set_error_policy) (CupsPkHelper* self, const gchar* name, const gchar* policy, GError** error);
	gchar* (*printer_set_op_policy) (CupsPkHelper* self, const gchar* name, const gchar* policy, GError** error);
	gchar* (*printer_set_users_allowed) (CupsPkHelper* self, const gchar* name, gchar** users, gint users_length1, GError** error);
	gchar* (*printer_set_users_denied) (CupsPkHelper* self, const gchar* name, gchar** users, gint users_length1, GError** error);
	gchar* (*printer_add_option_default) (CupsPkHelper* self, const gchar* name, const gchar* option, gchar** values, gint values_length1, GError** error);
	gchar* (*printer_delete_option_default) (CupsPkHelper* self, const gchar* name, const gchar* option, GError** error);
	gchar* (*printer_add_option) (CupsPkHelper* self, const gchar* name, const gchar* option, gchar** values, gint values_length1, GError** error);
	gchar* (*job_cancel_purge) (CupsPkHelper* self, gint jobid, gboolean purge, GError** error);
	gchar* (*job_restart) (CupsPkHelper* self, gint jobid, GError** error);
	gchar* (*job_set_hold_until) (CupsPkHelper* self, gint jobid, const gchar* job_hold_until, GError** error);
};

struct _CupsPkHelperDevicesGetReadyData {
	GDBusMethodInvocation* _invocation_;
	gint timeout;
	gint limit;
	gchar** include_schemes;
	gint include_schemes_length1;
	gchar** exclude_schemes;
	gint exclude_schemes_length1;
};

extern CupsPkHelper* cups_pk_helper;
CupsPkHelper* cups_pk_helper = NULL;

GType cups_pk_helper_proxy_get_type (void) G_GNUC_CONST;
guint cups_pk_helper_register_object (void* object,
                                      GDBusConnection* connection,
                                      const gchar* path,
                                      GError** error);
GType cups_pk_helper_get_type (void) G_GNUC_CONST;
gchar* cups_pk_helper_file_get (CupsPkHelper* self,
                                const gchar* resource,
                                const gchar* filename,
                                GError** error);
gchar* cups_pk_helper_file_put (CupsPkHelper* self,
                                const gchar* resource,
                                const gchar* filename,
                                GError** error);
void cups_pk_helper_server_get_settings (CupsPkHelper* self,
                                         gchar* * _error_,
                                         GHashTable* * settings,
                                         GError** error);
gchar* cups_pk_helper_server_set_settings (CupsPkHelper* self,
                                           GHashTable* settings,
                                           GError** error);
void cups_pk_helper_devices_get (CupsPkHelper* self,
                                 gint timeout,
                                 gint limit,
                                 gchar** include_schemes,
                                 gint include_schemes_length1,
                                 gchar** exclude_schemes,
                                 gint exclude_schemes_length1,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
void cups_pk_helper_devices_get_finish (CupsPkHelper* self,
                                        GAsyncResult* _res_,
                                        gchar* * _error_,
                                        GHashTable* * devices,
                                        GError** error);
gchar* cups_pk_helper_printer_add (CupsPkHelper* self,
                                   const gchar* name,
                                   const gchar* uri,
                                   const gchar* ppd,
                                   const gchar* info,
                                   const gchar* location,
                                   GError** error);
gchar* cups_pk_helper_printer_add_with_ppd_file (CupsPkHelper* self,
                                                 const gchar* name,
                                                 const gchar* uri,
                                                 const gchar* ppd,
                                                 const gchar* info,
                                                 const gchar* location,
                                                 GError** error);
gchar* cups_pk_helper_printer_set_device (CupsPkHelper* self,
                                          const gchar* name,
                                          const gchar* device,
                                          GError** error);
gchar* cups_pk_helper_printer_set_default (CupsPkHelper* self,
                                           const gchar* name,
                                           GError** error);
gchar* cups_pk_helper_printer_set_enabled (CupsPkHelper* self,
                                           const gchar* name,
                                           gboolean enabled,
                                           GError** error);
gchar* cups_pk_helper_printer_set_accept_jobs (CupsPkHelper* self,
                                               const gchar* name,
                                               gboolean enabled,
                                               const gchar* reason,
                                               GError** error);
gchar* cups_pk_helper_printer_delete (CupsPkHelper* self,
                                      const gchar* name,
                                      GError** error);
gchar* cups_pk_helper_class_add_printer (CupsPkHelper* self,
                                         const gchar* name,
                                         const gchar* printer,
                                         GError** error);
gchar* cups_pk_helper_class_delete_printer (CupsPkHelper* self,
                                            const gchar* name,
                                            const gchar* printer,
                                            GError** error);
gchar* cups_pk_helper_class_delete (CupsPkHelper* self,
                                    const gchar* name,
                                    GError** error);
gchar* cups_pk_helper_printer_set_info (CupsPkHelper* self,
                                        const gchar* name,
                                        const gchar* info,
                                        GError** error);
gchar* cups_pk_helper_printer_set_location (CupsPkHelper* self,
                                            const gchar* name,
                                            const gchar* location,
                                            GError** error);
gchar* cups_pk_helper_printer_set_shared (CupsPkHelper* self,
                                          const gchar* name,
                                          gboolean shared,
                                          GError** error);
gchar* cups_pk_helper_printer_set_job_sheets (CupsPkHelper* self,
                                              const gchar* name,
                                              const gchar* start,
                                              const gchar* end,
                                              GError** error);
gchar* cups_pk_helper_printer_set_error_policy (CupsPkHelper* self,
                                                const gchar* name,
                                                const gchar* policy,
                                                GError** error);
gchar* cups_pk_helper_printer_set_op_policy (CupsPkHelper* self,
                                             const gchar* name,
                                             const gchar* policy,
                                             GError** error);
gchar* cups_pk_helper_printer_set_users_allowed (CupsPkHelper* self,
                                                 const gchar* name,
                                                 gchar** users,
                                                 gint users_length1,
                                                 GError** error);
gchar* cups_pk_helper_printer_set_users_denied (CupsPkHelper* self,
                                                const gchar* name,
                                                gchar** users,
                                                gint users_length1,
                                                GError** error);
gchar* cups_pk_helper_printer_add_option_default (CupsPkHelper* self,
                                                  const gchar* name,
                                                  const gchar* option,
                                                  gchar** values,
                                                  gint values_length1,
                                                  GError** error);
gchar* cups_pk_helper_printer_delete_option_default (CupsPkHelper* self,
                                                     const gchar* name,
                                                     const gchar* option,
                                                     GError** error);
gchar* cups_pk_helper_printer_add_option (CupsPkHelper* self,
                                          const gchar* name,
                                          const gchar* option,
                                          gchar** values,
                                          gint values_length1,
                                          GError** error);
gchar* cups_pk_helper_job_cancel_purge (CupsPkHelper* self,
                                        gint jobid,
                                        gboolean purge,
                                        GError** error);
gchar* cups_pk_helper_job_restart (CupsPkHelper* self,
                                   gint jobid,
                                   GError** error);
gchar* cups_pk_helper_job_set_hold_until (CupsPkHelper* self,
                                          gint jobid,
                                          const gchar* job_hold_until,
                                          GError** error);
static void cups_pk_helper_proxy_g_signal (GDBusProxy* proxy,
                                    const gchar* sender_name,
                                    const gchar* signal_name,
                                    GVariant* parameters);
static gchar* cups_pk_helper_proxy_file_get (CupsPkHelper* self,
                                      const gchar* resource,
                                      const gchar* filename,
                                      GError** error);
static gchar* cups_pk_helper_proxy_file_put (CupsPkHelper* self,
                                      const gchar* resource,
                                      const gchar* filename,
                                      GError** error);
static void cups_pk_helper_proxy_server_get_settings (CupsPkHelper* self,
                                               gchar* * _error_,
                                               GHashTable* * settings,
                                               GError** error);
static gchar* cups_pk_helper_proxy_server_set_settings (CupsPkHelper* self,
                                                 GHashTable* settings,
                                                 GError** error);
static void _vala_g_async_ready_callback (GObject *source_object,
                                   GAsyncResult *res,
                                   void *user_data);
static void cups_pk_helper_proxy_devices_get_async (CupsPkHelper* self,
                                             gint timeout,
                                             gint limit,
                                             gchar** include_schemes,
                                             gint include_schemes_length1,
                                             gchar** exclude_schemes,
                                             gint exclude_schemes_length1,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static void cups_pk_helper_proxy_devices_get_finish (CupsPkHelper* self,
                                              GAsyncResult* _res_,
                                              gchar* * _error_,
                                              GHashTable* * devices,
                                              GError** error);
static gchar* cups_pk_helper_proxy_printer_add (CupsPkHelper* self,
                                         const gchar* name,
                                         const gchar* uri,
                                         const gchar* ppd,
                                         const gchar* info,
                                         const gchar* location,
                                         GError** error);
static gchar* cups_pk_helper_proxy_printer_add_with_ppd_file (CupsPkHelper* self,
                                                       const gchar* name,
                                                       const gchar* uri,
                                                       const gchar* ppd,
                                                       const gchar* info,
                                                       const gchar* location,
                                                       GError** error);
static gchar* cups_pk_helper_proxy_printer_set_device (CupsPkHelper* self,
                                                const gchar* name,
                                                const gchar* device,
                                                GError** error);
static gchar* cups_pk_helper_proxy_printer_set_default (CupsPkHelper* self,
                                                 const gchar* name,
                                                 GError** error);
static gchar* cups_pk_helper_proxy_printer_set_enabled (CupsPkHelper* self,
                                                 const gchar* name,
                                                 gboolean enabled,
                                                 GError** error);
static gchar* cups_pk_helper_proxy_printer_set_accept_jobs (CupsPkHelper* self,
                                                     const gchar* name,
                                                     gboolean enabled,
                                                     const gchar* reason,
                                                     GError** error);
static gchar* cups_pk_helper_proxy_printer_delete (CupsPkHelper* self,
                                            const gchar* name,
                                            GError** error);
static gchar* cups_pk_helper_proxy_class_add_printer (CupsPkHelper* self,
                                               const gchar* name,
                                               const gchar* printer,
                                               GError** error);
static gchar* cups_pk_helper_proxy_class_delete_printer (CupsPkHelper* self,
                                                  const gchar* name,
                                                  const gchar* printer,
                                                  GError** error);
static gchar* cups_pk_helper_proxy_class_delete (CupsPkHelper* self,
                                          const gchar* name,
                                          GError** error);
static gchar* cups_pk_helper_proxy_printer_set_info (CupsPkHelper* self,
                                              const gchar* name,
                                              const gchar* info,
                                              GError** error);
static gchar* cups_pk_helper_proxy_printer_set_location (CupsPkHelper* self,
                                                  const gchar* name,
                                                  const gchar* location,
                                                  GError** error);
static gchar* cups_pk_helper_proxy_printer_set_shared (CupsPkHelper* self,
                                                const gchar* name,
                                                gboolean shared,
                                                GError** error);
static gchar* cups_pk_helper_proxy_printer_set_job_sheets (CupsPkHelper* self,
                                                    const gchar* name,
                                                    const gchar* start,
                                                    const gchar* end,
                                                    GError** error);
static gchar* cups_pk_helper_proxy_printer_set_error_policy (CupsPkHelper* self,
                                                      const gchar* name,
                                                      const gchar* policy,
                                                      GError** error);
static gchar* cups_pk_helper_proxy_printer_set_op_policy (CupsPkHelper* self,
                                                   const gchar* name,
                                                   const gchar* policy,
                                                   GError** error);
static gchar* cups_pk_helper_proxy_printer_set_users_allowed (CupsPkHelper* self,
                                                       const gchar* name,
                                                       gchar** users,
                                                       gint users_length1,
                                                       GError** error);
static gchar* cups_pk_helper_proxy_printer_set_users_denied (CupsPkHelper* self,
                                                      const gchar* name,
                                                      gchar** users,
                                                      gint users_length1,
                                                      GError** error);
static gchar* cups_pk_helper_proxy_printer_add_option_default (CupsPkHelper* self,
                                                        const gchar* name,
                                                        const gchar* option,
                                                        gchar** values,
                                                        gint values_length1,
                                                        GError** error);
static gchar* cups_pk_helper_proxy_printer_delete_option_default (CupsPkHelper* self,
                                                           const gchar* name,
                                                           const gchar* option,
                                                           GError** error);
static gchar* cups_pk_helper_proxy_printer_add_option (CupsPkHelper* self,
                                                const gchar* name,
                                                const gchar* option,
                                                gchar** values,
                                                gint values_length1,
                                                GError** error);
static gchar* cups_pk_helper_proxy_job_cancel_purge (CupsPkHelper* self,
                                              gint jobid,
                                              gboolean purge,
                                              GError** error);
static gchar* cups_pk_helper_proxy_job_restart (CupsPkHelper* self,
                                         gint jobid,
                                         GError** error);
static gchar* cups_pk_helper_proxy_job_set_hold_until (CupsPkHelper* self,
                                                gint jobid,
                                                const gchar* job_hold_until,
                                                GError** error);
static void cups_pk_helper_proxy_cups_pk_helper_interface_init (CupsPkHelperIface* iface);
static void _dbus_cups_pk_helper_file_get (CupsPkHelper* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_file_put (CupsPkHelper* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_server_get_settings (CupsPkHelper* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_server_set_settings (CupsPkHelper* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_devices_get (CupsPkHelper* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_devices_get_ready (GObject * source_object,
                                             GAsyncResult * _res_,
                                             gpointer _user_data_);
static void _dbus_cups_pk_helper_printer_add (CupsPkHelper* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_add_with_ppd_file (CupsPkHelper* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_device (CupsPkHelper* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_default (CupsPkHelper* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_enabled (CupsPkHelper* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_accept_jobs (CupsPkHelper* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_delete (CupsPkHelper* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_class_add_printer (CupsPkHelper* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_class_delete_printer (CupsPkHelper* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_class_delete (CupsPkHelper* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_info (CupsPkHelper* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_location (CupsPkHelper* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_shared (CupsPkHelper* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_job_sheets (CupsPkHelper* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_error_policy (CupsPkHelper* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_op_policy (CupsPkHelper* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_users_allowed (CupsPkHelper* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_set_users_denied (CupsPkHelper* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_add_option_default (CupsPkHelper* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_delete_option_default (CupsPkHelper* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_printer_add_option (CupsPkHelper* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_job_cancel_purge (CupsPkHelper* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_job_restart (CupsPkHelper* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation);
static void _dbus_cups_pk_helper_job_set_hold_until (CupsPkHelper* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void cups_pk_helper_dbus_interface_method_call (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* method_name,
                                                GVariant* parameters,
                                                GDBusMethodInvocation* invocation,
                                                gpointer user_data);
static GVariant* cups_pk_helper_dbus_interface_get_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GError** error,
                                                      gpointer user_data);
static gboolean cups_pk_helper_dbus_interface_set_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GVariant* value,
                                                     GError** error,
                                                     gpointer user_data);
static void _cups_pk_helper_unregister_object (gpointer user_data);
CupsPkHelper* cups_get_pk_helper (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_file_get_resource = {-1, "resource", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_file_get_filename = {-1, "filename", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_file_get_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_file_get_in[] = {&_cups_pk_helper_dbus_arg_info_file_get_resource, &_cups_pk_helper_dbus_arg_info_file_get_filename, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_file_get_out[] = {&_cups_pk_helper_dbus_arg_info_file_get_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_file_get = {-1, "FileGet", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_file_get_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_file_get_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_file_put_resource = {-1, "resource", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_file_put_filename = {-1, "filename", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_file_put_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_file_put_in[] = {&_cups_pk_helper_dbus_arg_info_file_put_resource, &_cups_pk_helper_dbus_arg_info_file_put_filename, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_file_put_out[] = {&_cups_pk_helper_dbus_arg_info_file_put_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_file_put = {-1, "FilePut", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_file_put_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_file_put_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_server_get_settings_error = {-1, "error", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_server_get_settings_settings = {-1, "settings", "a{ss}", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_server_get_settings_in[] = {NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_server_get_settings_out[] = {&_cups_pk_helper_dbus_arg_info_server_get_settings_error, &_cups_pk_helper_dbus_arg_info_server_get_settings_settings, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_server_get_settings = {-1, "ServerGetSettings", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_server_get_settings_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_server_get_settings_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_server_set_settings_settings = {-1, "settings", "a{ss}", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_server_set_settings_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_server_set_settings_in[] = {&_cups_pk_helper_dbus_arg_info_server_set_settings_settings, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_server_set_settings_out[] = {&_cups_pk_helper_dbus_arg_info_server_set_settings_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_server_set_settings = {-1, "ServerSetSettings", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_server_set_settings_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_server_set_settings_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_devices_get_timeout = {-1, "timeout", "i", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_devices_get_limit = {-1, "limit", "i", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_devices_get_include_schemes = {-1, "include_schemes", "as", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_devices_get_exclude_schemes = {-1, "exclude_schemes", "as", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_devices_get_error = {-1, "error", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_devices_get_devices = {-1, "devices", "a{ss}", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_devices_get_in[] = {&_cups_pk_helper_dbus_arg_info_devices_get_timeout, &_cups_pk_helper_dbus_arg_info_devices_get_limit, &_cups_pk_helper_dbus_arg_info_devices_get_include_schemes, &_cups_pk_helper_dbus_arg_info_devices_get_exclude_schemes, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_devices_get_out[] = {&_cups_pk_helper_dbus_arg_info_devices_get_error, &_cups_pk_helper_dbus_arg_info_devices_get_devices, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_devices_get = {-1, "DevicesGet", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_devices_get_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_devices_get_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_uri = {-1, "uri", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_ppd = {-1, "ppd", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_info = {-1, "info", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_location = {-1, "location", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_add_in[] = {&_cups_pk_helper_dbus_arg_info_printer_add_name, &_cups_pk_helper_dbus_arg_info_printer_add_uri, &_cups_pk_helper_dbus_arg_info_printer_add_ppd, &_cups_pk_helper_dbus_arg_info_printer_add_info, &_cups_pk_helper_dbus_arg_info_printer_add_location, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_add_out[] = {&_cups_pk_helper_dbus_arg_info_printer_add_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_add = {-1, "PrinterAdd", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_add_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_add_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_uri = {-1, "uri", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_ppd = {-1, "ppd", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_info = {-1, "info", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_location = {-1, "location", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_in[] = {&_cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_name, &_cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_uri, &_cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_ppd, &_cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_info, &_cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_location, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_out[] = {&_cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_add_with_ppd_file = {-1, "PrinterAddWithPpdFile", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_add_with_ppd_file_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_device_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_device_device = {-1, "device", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_device_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_device_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_device_name, &_cups_pk_helper_dbus_arg_info_printer_set_device_device, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_device_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_device_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_device = {-1, "PrinterSetDevice", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_device_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_device_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_default_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_default_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_default_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_default_name, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_default_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_default_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_default = {-1, "PrinterSetDefault", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_default_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_default_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_enabled_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_enabled_enabled = {-1, "enabled", "b", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_enabled_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_enabled_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_enabled_name, &_cups_pk_helper_dbus_arg_info_printer_set_enabled_enabled, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_enabled_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_enabled_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_enabled = {-1, "PrinterSetEnabled", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_enabled_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_enabled_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_enabled = {-1, "enabled", "b", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_reason = {-1, "reason", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_name, &_cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_enabled, &_cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_reason, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_accept_jobs = {-1, "PrinterSetAcceptJobs", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_accept_jobs_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_delete_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_delete_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_delete_in[] = {&_cups_pk_helper_dbus_arg_info_printer_delete_name, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_delete_out[] = {&_cups_pk_helper_dbus_arg_info_printer_delete_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_delete = {-1, "PrinterDelete", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_delete_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_delete_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_class_add_printer_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_class_add_printer_printer = {-1, "printer", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_class_add_printer_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_class_add_printer_in[] = {&_cups_pk_helper_dbus_arg_info_class_add_printer_name, &_cups_pk_helper_dbus_arg_info_class_add_printer_printer, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_class_add_printer_out[] = {&_cups_pk_helper_dbus_arg_info_class_add_printer_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_class_add_printer = {-1, "ClassAddPrinter", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_class_add_printer_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_class_add_printer_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_class_delete_printer_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_class_delete_printer_printer = {-1, "printer", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_class_delete_printer_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_class_delete_printer_in[] = {&_cups_pk_helper_dbus_arg_info_class_delete_printer_name, &_cups_pk_helper_dbus_arg_info_class_delete_printer_printer, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_class_delete_printer_out[] = {&_cups_pk_helper_dbus_arg_info_class_delete_printer_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_class_delete_printer = {-1, "ClassDeletePrinter", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_class_delete_printer_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_class_delete_printer_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_class_delete_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_class_delete_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_class_delete_in[] = {&_cups_pk_helper_dbus_arg_info_class_delete_name, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_class_delete_out[] = {&_cups_pk_helper_dbus_arg_info_class_delete_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_class_delete = {-1, "ClassDelete", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_class_delete_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_class_delete_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_info_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_info_info = {-1, "info", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_info_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_info_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_info_name, &_cups_pk_helper_dbus_arg_info_printer_set_info_info, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_info_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_info_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_info = {-1, "PrinterSetInfo", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_info_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_info_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_location_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_location_location = {-1, "location", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_location_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_location_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_location_name, &_cups_pk_helper_dbus_arg_info_printer_set_location_location, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_location_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_location_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_location = {-1, "PrinterSetLocation", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_location_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_location_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_shared_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_shared_shared = {-1, "shared", "b", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_shared_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_shared_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_shared_name, &_cups_pk_helper_dbus_arg_info_printer_set_shared_shared, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_shared_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_shared_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_shared = {-1, "PrinterSetShared", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_shared_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_shared_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_job_sheets_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_job_sheets_start = {-1, "start", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_job_sheets_end = {-1, "end", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_job_sheets_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_job_sheets_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_job_sheets_name, &_cups_pk_helper_dbus_arg_info_printer_set_job_sheets_start, &_cups_pk_helper_dbus_arg_info_printer_set_job_sheets_end, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_job_sheets_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_job_sheets_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_job_sheets = {-1, "PrinterSetJobSheets", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_job_sheets_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_job_sheets_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_error_policy_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_error_policy_policy = {-1, "policy", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_error_policy_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_error_policy_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_error_policy_name, &_cups_pk_helper_dbus_arg_info_printer_set_error_policy_policy, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_error_policy_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_error_policy_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_error_policy = {-1, "PrinterSetErrorPolicy", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_error_policy_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_error_policy_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_op_policy_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_op_policy_policy = {-1, "policy", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_op_policy_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_op_policy_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_op_policy_name, &_cups_pk_helper_dbus_arg_info_printer_set_op_policy_policy, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_op_policy_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_op_policy_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_op_policy = {-1, "PrinterSetOpPolicy", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_op_policy_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_op_policy_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_users_allowed_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_users_allowed_users = {-1, "users", "as", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_users_allowed_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_users_allowed_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_users_allowed_name, &_cups_pk_helper_dbus_arg_info_printer_set_users_allowed_users, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_users_allowed_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_users_allowed_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_users_allowed = {-1, "PrinterSetUsersAllowed", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_users_allowed_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_users_allowed_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_users_denied_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_users_denied_users = {-1, "users", "as", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_set_users_denied_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_users_denied_in[] = {&_cups_pk_helper_dbus_arg_info_printer_set_users_denied_name, &_cups_pk_helper_dbus_arg_info_printer_set_users_denied_users, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_set_users_denied_out[] = {&_cups_pk_helper_dbus_arg_info_printer_set_users_denied_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_set_users_denied = {-1, "PrinterSetUsersDenied", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_users_denied_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_set_users_denied_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_option_default_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_option_default_option = {-1, "option", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_option_default_values = {-1, "values", "as", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_option_default_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_add_option_default_in[] = {&_cups_pk_helper_dbus_arg_info_printer_add_option_default_name, &_cups_pk_helper_dbus_arg_info_printer_add_option_default_option, &_cups_pk_helper_dbus_arg_info_printer_add_option_default_values, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_add_option_default_out[] = {&_cups_pk_helper_dbus_arg_info_printer_add_option_default_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_add_option_default = {-1, "PrinterAddOptionDefault", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_add_option_default_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_add_option_default_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_delete_option_default_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_delete_option_default_option = {-1, "option", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_delete_option_default_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_delete_option_default_in[] = {&_cups_pk_helper_dbus_arg_info_printer_delete_option_default_name, &_cups_pk_helper_dbus_arg_info_printer_delete_option_default_option, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_delete_option_default_out[] = {&_cups_pk_helper_dbus_arg_info_printer_delete_option_default_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_delete_option_default = {-1, "PrinterDeleteOptionDefault", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_delete_option_default_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_delete_option_default_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_option_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_option_option = {-1, "option", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_option_values = {-1, "values", "as", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_printer_add_option_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_add_option_in[] = {&_cups_pk_helper_dbus_arg_info_printer_add_option_name, &_cups_pk_helper_dbus_arg_info_printer_add_option_option, &_cups_pk_helper_dbus_arg_info_printer_add_option_values, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_printer_add_option_out[] = {&_cups_pk_helper_dbus_arg_info_printer_add_option_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_printer_add_option = {-1, "PrinterAddOption", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_add_option_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_printer_add_option_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_job_cancel_purge_jobid = {-1, "jobid", "i", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_job_cancel_purge_purge = {-1, "purge", "b", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_job_cancel_purge_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_job_cancel_purge_in[] = {&_cups_pk_helper_dbus_arg_info_job_cancel_purge_jobid, &_cups_pk_helper_dbus_arg_info_job_cancel_purge_purge, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_job_cancel_purge_out[] = {&_cups_pk_helper_dbus_arg_info_job_cancel_purge_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_job_cancel_purge = {-1, "JobCancelPurge", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_job_cancel_purge_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_job_cancel_purge_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_job_restart_jobid = {-1, "jobid", "i", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_job_restart_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_job_restart_in[] = {&_cups_pk_helper_dbus_arg_info_job_restart_jobid, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_job_restart_out[] = {&_cups_pk_helper_dbus_arg_info_job_restart_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_job_restart = {-1, "JobRestart", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_job_restart_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_job_restart_out), NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_job_set_hold_until_jobid = {-1, "jobid", "i", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_job_set_hold_until_job_hold_until = {-1, "job_hold_until", "s", NULL};
static const GDBusArgInfo _cups_pk_helper_dbus_arg_info_job_set_hold_until_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_job_set_hold_until_in[] = {&_cups_pk_helper_dbus_arg_info_job_set_hold_until_jobid, &_cups_pk_helper_dbus_arg_info_job_set_hold_until_job_hold_until, NULL};
static const GDBusArgInfo * const _cups_pk_helper_dbus_arg_info_job_set_hold_until_out[] = {&_cups_pk_helper_dbus_arg_info_job_set_hold_until_result, NULL};
static const GDBusMethodInfo _cups_pk_helper_dbus_method_info_job_set_hold_until = {-1, "JobSetHoldUntil", (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_job_set_hold_until_in), (GDBusArgInfo **) (&_cups_pk_helper_dbus_arg_info_job_set_hold_until_out), NULL};
static const GDBusMethodInfo * const _cups_pk_helper_dbus_method_info[] = {&_cups_pk_helper_dbus_method_info_file_get, &_cups_pk_helper_dbus_method_info_file_put, &_cups_pk_helper_dbus_method_info_server_get_settings, &_cups_pk_helper_dbus_method_info_server_set_settings, &_cups_pk_helper_dbus_method_info_devices_get, &_cups_pk_helper_dbus_method_info_printer_add, &_cups_pk_helper_dbus_method_info_printer_add_with_ppd_file, &_cups_pk_helper_dbus_method_info_printer_set_device, &_cups_pk_helper_dbus_method_info_printer_set_default, &_cups_pk_helper_dbus_method_info_printer_set_enabled, &_cups_pk_helper_dbus_method_info_printer_set_accept_jobs, &_cups_pk_helper_dbus_method_info_printer_delete, &_cups_pk_helper_dbus_method_info_class_add_printer, &_cups_pk_helper_dbus_method_info_class_delete_printer, &_cups_pk_helper_dbus_method_info_class_delete, &_cups_pk_helper_dbus_method_info_printer_set_info, &_cups_pk_helper_dbus_method_info_printer_set_location, &_cups_pk_helper_dbus_method_info_printer_set_shared, &_cups_pk_helper_dbus_method_info_printer_set_job_sheets, &_cups_pk_helper_dbus_method_info_printer_set_error_policy, &_cups_pk_helper_dbus_method_info_printer_set_op_policy, &_cups_pk_helper_dbus_method_info_printer_set_users_allowed, &_cups_pk_helper_dbus_method_info_printer_set_users_denied, &_cups_pk_helper_dbus_method_info_printer_add_option_default, &_cups_pk_helper_dbus_method_info_printer_delete_option_default, &_cups_pk_helper_dbus_method_info_printer_add_option, &_cups_pk_helper_dbus_method_info_job_cancel_purge, &_cups_pk_helper_dbus_method_info_job_restart, &_cups_pk_helper_dbus_method_info_job_set_hold_until, NULL};
static const GDBusSignalInfo * const _cups_pk_helper_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _cups_pk_helper_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _cups_pk_helper_dbus_interface_info = {-1, "org.opensuse.CupsPkHelper.Mechanism", (GDBusMethodInfo **) (&_cups_pk_helper_dbus_method_info), (GDBusSignalInfo **) (&_cups_pk_helper_dbus_signal_info), (GDBusPropertyInfo **) (&_cups_pk_helper_dbus_property_info), NULL};
static const GDBusInterfaceVTable _cups_pk_helper_dbus_interface_vtable = {cups_pk_helper_dbus_interface_method_call, cups_pk_helper_dbus_interface_get_property, cups_pk_helper_dbus_interface_set_property};

gchar*
cups_pk_helper_file_get (CupsPkHelper* self,
                         const gchar* resource,
                         const gchar* filename,
                         GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->file_get (self, resource, filename, error);
}

gchar*
cups_pk_helper_file_put (CupsPkHelper* self,
                         const gchar* resource,
                         const gchar* filename,
                         GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->file_put (self, resource, filename, error);
}

void
cups_pk_helper_server_get_settings (CupsPkHelper* self,
                                    gchar* * _error_,
                                    GHashTable* * settings,
                                    GError** error)
{
	g_return_if_fail (self != NULL);
	CUPS_PK_HELPER_GET_INTERFACE (self)->server_get_settings (self, _error_, settings, error);
}

gchar*
cups_pk_helper_server_set_settings (CupsPkHelper* self,
                                    GHashTable* settings,
                                    GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->server_set_settings (self, settings, error);
}

void
cups_pk_helper_devices_get (CupsPkHelper* self,
                            gint timeout,
                            gint limit,
                            gchar** include_schemes,
                            gint include_schemes_length1,
                            gchar** exclude_schemes,
                            gint exclude_schemes_length1,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	CUPS_PK_HELPER_GET_INTERFACE (self)->devices_get (self, timeout, limit, include_schemes, include_schemes_length1, exclude_schemes, exclude_schemes_length1, _callback_, _user_data_);
}

void
cups_pk_helper_devices_get_finish (CupsPkHelper* self,
                                   GAsyncResult* _res_,
                                   gchar* * _error_,
                                   GHashTable* * devices,
                                   GError** error)
{
	CUPS_PK_HELPER_GET_INTERFACE (self)->devices_get_finish (self, _res_, _error_, devices, error);
}

gchar*
cups_pk_helper_printer_add (CupsPkHelper* self,
                            const gchar* name,
                            const gchar* uri,
                            const gchar* ppd,
                            const gchar* info,
                            const gchar* location,
                            GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_add (self, name, uri, ppd, info, location, error);
}

gchar*
cups_pk_helper_printer_add_with_ppd_file (CupsPkHelper* self,
                                          const gchar* name,
                                          const gchar* uri,
                                          const gchar* ppd,
                                          const gchar* info,
                                          const gchar* location,
                                          GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_add_with_ppd_file (self, name, uri, ppd, info, location, error);
}

gchar*
cups_pk_helper_printer_set_device (CupsPkHelper* self,
                                   const gchar* name,
                                   const gchar* device,
                                   GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_device (self, name, device, error);
}

gchar*
cups_pk_helper_printer_set_default (CupsPkHelper* self,
                                    const gchar* name,
                                    GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_default (self, name, error);
}

gchar*
cups_pk_helper_printer_set_enabled (CupsPkHelper* self,
                                    const gchar* name,
                                    gboolean enabled,
                                    GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_enabled (self, name, enabled, error);
}

gchar*
cups_pk_helper_printer_set_accept_jobs (CupsPkHelper* self,
                                        const gchar* name,
                                        gboolean enabled,
                                        const gchar* reason,
                                        GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_accept_jobs (self, name, enabled, reason, error);
}

gchar*
cups_pk_helper_printer_delete (CupsPkHelper* self,
                               const gchar* name,
                               GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_delete (self, name, error);
}

gchar*
cups_pk_helper_class_add_printer (CupsPkHelper* self,
                                  const gchar* name,
                                  const gchar* printer,
                                  GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->class_add_printer (self, name, printer, error);
}

gchar*
cups_pk_helper_class_delete_printer (CupsPkHelper* self,
                                     const gchar* name,
                                     const gchar* printer,
                                     GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->class_delete_printer (self, name, printer, error);
}

gchar*
cups_pk_helper_class_delete (CupsPkHelper* self,
                             const gchar* name,
                             GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->class_delete (self, name, error);
}

gchar*
cups_pk_helper_printer_set_info (CupsPkHelper* self,
                                 const gchar* name,
                                 const gchar* info,
                                 GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_info (self, name, info, error);
}

gchar*
cups_pk_helper_printer_set_location (CupsPkHelper* self,
                                     const gchar* name,
                                     const gchar* location,
                                     GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_location (self, name, location, error);
}

gchar*
cups_pk_helper_printer_set_shared (CupsPkHelper* self,
                                   const gchar* name,
                                   gboolean shared,
                                   GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_shared (self, name, shared, error);
}

gchar*
cups_pk_helper_printer_set_job_sheets (CupsPkHelper* self,
                                       const gchar* name,
                                       const gchar* start,
                                       const gchar* end,
                                       GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_job_sheets (self, name, start, end, error);
}

gchar*
cups_pk_helper_printer_set_error_policy (CupsPkHelper* self,
                                         const gchar* name,
                                         const gchar* policy,
                                         GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_error_policy (self, name, policy, error);
}

gchar*
cups_pk_helper_printer_set_op_policy (CupsPkHelper* self,
                                      const gchar* name,
                                      const gchar* policy,
                                      GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_op_policy (self, name, policy, error);
}

gchar*
cups_pk_helper_printer_set_users_allowed (CupsPkHelper* self,
                                          const gchar* name,
                                          gchar** users,
                                          gint users_length1,
                                          GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_users_allowed (self, name, users, users_length1, error);
}

gchar*
cups_pk_helper_printer_set_users_denied (CupsPkHelper* self,
                                         const gchar* name,
                                         gchar** users,
                                         gint users_length1,
                                         GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_set_users_denied (self, name, users, users_length1, error);
}

gchar*
cups_pk_helper_printer_add_option_default (CupsPkHelper* self,
                                           const gchar* name,
                                           const gchar* option,
                                           gchar** values,
                                           gint values_length1,
                                           GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_add_option_default (self, name, option, values, values_length1, error);
}

gchar*
cups_pk_helper_printer_delete_option_default (CupsPkHelper* self,
                                              const gchar* name,
                                              const gchar* option,
                                              GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_delete_option_default (self, name, option, error);
}

gchar*
cups_pk_helper_printer_add_option (CupsPkHelper* self,
                                   const gchar* name,
                                   const gchar* option,
                                   gchar** values,
                                   gint values_length1,
                                   GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->printer_add_option (self, name, option, values, values_length1, error);
}

gchar*
cups_pk_helper_job_cancel_purge (CupsPkHelper* self,
                                 gint jobid,
                                 gboolean purge,
                                 GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->job_cancel_purge (self, jobid, purge, error);
}

gchar*
cups_pk_helper_job_restart (CupsPkHelper* self,
                            gint jobid,
                            GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->job_restart (self, jobid, error);
}

gchar*
cups_pk_helper_job_set_hold_until (CupsPkHelper* self,
                                   gint jobid,
                                   const gchar* job_hold_until,
                                   GError** error)
{
	g_return_val_if_fail (self != NULL, NULL);
	return CUPS_PK_HELPER_GET_INTERFACE (self)->job_set_hold_until (self, jobid, job_hold_until, error);
}

static void
cups_pk_helper_default_init (CupsPkHelperIface * iface,
                             gpointer iface_data)
{
}

GType
cups_pk_helper_get_type (void)
{
	static volatile gsize cups_pk_helper_type_id__volatile = 0;
	if (g_once_init_enter (&cups_pk_helper_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CupsPkHelperIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cups_pk_helper_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType cups_pk_helper_type_id;
		cups_pk_helper_type_id = g_type_register_static (G_TYPE_INTERFACE, "CupsPkHelper", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (cups_pk_helper_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (cups_pk_helper_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) cups_pk_helper_proxy_get_type);
		g_type_set_qdata (cups_pk_helper_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.opensuse.CupsPkHelper.Mechanism");
		g_type_set_qdata (cups_pk_helper_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_cups_pk_helper_dbus_interface_info));
		g_type_set_qdata (cups_pk_helper_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) cups_pk_helper_register_object);
		g_once_init_leave (&cups_pk_helper_type_id__volatile, cups_pk_helper_type_id);
	}
	return cups_pk_helper_type_id__volatile;
}

G_DEFINE_TYPE_EXTENDED (CupsPkHelperProxy, cups_pk_helper_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (CUPS_TYPE_PK_HELPER, cups_pk_helper_proxy_cups_pk_helper_interface_init) )
static void
cups_pk_helper_proxy_class_init (CupsPkHelperProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = cups_pk_helper_proxy_g_signal;
}

static void
cups_pk_helper_proxy_g_signal (GDBusProxy* proxy,
                               const gchar* sender_name,
                               const gchar* signal_name,
                               GVariant* parameters)
{
}

static void
cups_pk_helper_proxy_init (CupsPkHelperProxy* self)
{
}

static gchar*
cups_pk_helper_proxy_file_get (CupsPkHelper* self,
                               const gchar* resource,
                               const gchar* filename,
                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp0_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "FileGet");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (resource));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (filename));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp0_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_file_put (CupsPkHelper* self,
                               const gchar* resource,
                               const gchar* filename,
                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp1_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "FilePut");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (resource));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (filename));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp1_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	g_object_unref (_reply_message);
	return _result;
}

static void
cups_pk_helper_proxy_server_get_settings (CupsPkHelper* self,
                                          gchar* * _error_,
                                          GHashTable* * settings,
                                          GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _vala_error = NULL;
	GVariant* _tmp2_;
	GHashTable* _vala_settings = NULL;
	GVariant* _tmp3_;
	GHashTable* _tmp4_;
	GVariantIter _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "ServerGetSettings");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp2_ = g_variant_iter_next_value (&_reply_iter);
	_vala_error = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	*_error_ = _vala_error;
	_tmp3_ = g_variant_iter_next_value (&_reply_iter);
	_tmp4_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
	g_variant_iter_init (&_tmp5_, _tmp3_);
	while (g_variant_iter_loop (&_tmp5_, "{?*}", &_tmp6_, &_tmp7_)) {
		g_hash_table_insert (_tmp4_, g_variant_dup_string (_tmp6_, NULL), g_variant_dup_string (_tmp7_, NULL));
	}
	_vala_settings = _tmp4_;
	g_variant_unref (_tmp3_);
	*settings = _vala_settings;
	g_object_unref (_reply_message);
}

static gchar*
cups_pk_helper_proxy_server_set_settings (CupsPkHelper* self,
                                          GHashTable* settings,
                                          GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp8_;
	GHashTableIter _tmp9_;
	gpointer _tmp10_;
	gpointer _tmp11_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp12_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "ServerSetSettings");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp9_, settings);
	g_variant_builder_init (&_tmp8_, G_VARIANT_TYPE ("a{ss}"));
	while (g_hash_table_iter_next (&_tmp9_, &_tmp10_, &_tmp11_)) {
		gchar* _key;
		gchar* _value;
		_key = (gchar*) _tmp10_;
		_value = (gchar*) _tmp11_;
		g_variant_builder_add (&_tmp8_, "{?*}", g_variant_new_string (_key), g_variant_new_string (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp8_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp12_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	g_object_unref (_reply_message);
	return _result;
}

static void
_vala_g_async_ready_callback (GObject *source_object,
                              GAsyncResult *res,
                              void *user_data)
{
	g_task_return_pointer (user_data, g_object_ref (res), g_object_unref);
	g_object_unref (user_data);
}

static void
cups_pk_helper_proxy_devices_get_async (CupsPkHelper* self,
                                        gint timeout,
                                        gint limit,
                                        gchar** include_schemes,
                                        gint include_schemes_length1,
                                        gchar** exclude_schemes,
                                        gint exclude_schemes_length1,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp13_;
	GVariantBuilder _tmp14_;
	gint _tmp15_;
	gchar** _tmp16_;
	GVariantBuilder _tmp17_;
	gint _tmp18_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "DevicesGet");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (timeout));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (limit));
	_tmp13_ = include_schemes;
	g_variant_builder_init (&_tmp14_, G_VARIANT_TYPE ("as"));
	for (_tmp15_ = 0; _tmp15_ < include_schemes_length1; _tmp15_++) {
		g_variant_builder_add_value (&_tmp14_, g_variant_new_string (*_tmp13_));
		_tmp13_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp14_));
	_tmp16_ = exclude_schemes;
	g_variant_builder_init (&_tmp17_, G_VARIANT_TYPE ("as"));
	for (_tmp18_ = 0; _tmp18_ < exclude_schemes_length1; _tmp18_++) {
		g_variant_builder_add_value (&_tmp17_, g_variant_new_string (*_tmp16_));
		_tmp16_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp17_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
	g_object_unref (_message);
}

static void
cups_pk_helper_proxy_devices_get_finish (CupsPkHelper* self,
                                         GAsyncResult* _res_,
                                         gchar* * _error_,
                                         GHashTable* * devices,
                                         GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _vala_error = NULL;
	GVariant* _tmp19_;
	GHashTable* _vala_devices = NULL;
	GVariant* _tmp20_;
	GHashTable* _tmp21_;
	GVariantIter _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
	g_object_unref (_inner_res);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp19_ = g_variant_iter_next_value (&_reply_iter);
	_vala_error = g_variant_dup_string (_tmp19_, NULL);
	g_variant_unref (_tmp19_);
	*_error_ = _vala_error;
	_tmp20_ = g_variant_iter_next_value (&_reply_iter);
	_tmp21_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
	g_variant_iter_init (&_tmp22_, _tmp20_);
	while (g_variant_iter_loop (&_tmp22_, "{?*}", &_tmp23_, &_tmp24_)) {
		g_hash_table_insert (_tmp21_, g_variant_dup_string (_tmp23_, NULL), g_variant_dup_string (_tmp24_, NULL));
	}
	_vala_devices = _tmp21_;
	g_variant_unref (_tmp20_);
	*devices = _vala_devices;
	g_object_unref (_reply_message);
}

static gchar*
cups_pk_helper_proxy_printer_add (CupsPkHelper* self,
                                  const gchar* name,
                                  const gchar* uri,
                                  const gchar* ppd,
                                  const gchar* info,
                                  const gchar* location,
                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp25_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterAdd");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (ppd));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (info));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (location));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp25_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp25_, NULL);
	g_variant_unref (_tmp25_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_add_with_ppd_file (CupsPkHelper* self,
                                                const gchar* name,
                                                const gchar* uri,
                                                const gchar* ppd,
                                                const gchar* info,
                                                const gchar* location,
                                                GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp26_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterAddWithPpdFile");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (ppd));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (info));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (location));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp26_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp26_, NULL);
	g_variant_unref (_tmp26_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_device (CupsPkHelper* self,
                                         const gchar* name,
                                         const gchar* device,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp27_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetDevice");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (device));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp27_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp27_, NULL);
	g_variant_unref (_tmp27_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_default (CupsPkHelper* self,
                                          const gchar* name,
                                          GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp28_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetDefault");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp28_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp28_, NULL);
	g_variant_unref (_tmp28_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_enabled (CupsPkHelper* self,
                                          const gchar* name,
                                          gboolean enabled,
                                          GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp29_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetEnabled");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (enabled));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp29_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp29_, NULL);
	g_variant_unref (_tmp29_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_accept_jobs (CupsPkHelper* self,
                                              const gchar* name,
                                              gboolean enabled,
                                              const gchar* reason,
                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp30_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetAcceptJobs");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (enabled));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (reason));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp30_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp30_, NULL);
	g_variant_unref (_tmp30_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_delete (CupsPkHelper* self,
                                     const gchar* name,
                                     GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp31_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterDelete");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp31_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp31_, NULL);
	g_variant_unref (_tmp31_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_class_add_printer (CupsPkHelper* self,
                                        const gchar* name,
                                        const gchar* printer,
                                        GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp32_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "ClassAddPrinter");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (printer));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp32_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp32_, NULL);
	g_variant_unref (_tmp32_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_class_delete_printer (CupsPkHelper* self,
                                           const gchar* name,
                                           const gchar* printer,
                                           GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp33_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "ClassDeletePrinter");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (printer));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp33_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp33_, NULL);
	g_variant_unref (_tmp33_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_class_delete (CupsPkHelper* self,
                                   const gchar* name,
                                   GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp34_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "ClassDelete");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp34_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp34_, NULL);
	g_variant_unref (_tmp34_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_info (CupsPkHelper* self,
                                       const gchar* name,
                                       const gchar* info,
                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp35_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetInfo");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (info));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp35_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp35_, NULL);
	g_variant_unref (_tmp35_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_location (CupsPkHelper* self,
                                           const gchar* name,
                                           const gchar* location,
                                           GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp36_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetLocation");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (location));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp36_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp36_, NULL);
	g_variant_unref (_tmp36_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_shared (CupsPkHelper* self,
                                         const gchar* name,
                                         gboolean shared,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp37_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetShared");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (shared));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp37_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp37_, NULL);
	g_variant_unref (_tmp37_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_job_sheets (CupsPkHelper* self,
                                             const gchar* name,
                                             const gchar* start,
                                             const gchar* end,
                                             GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp38_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetJobSheets");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (start));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (end));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp38_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp38_, NULL);
	g_variant_unref (_tmp38_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_error_policy (CupsPkHelper* self,
                                               const gchar* name,
                                               const gchar* policy,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp39_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetErrorPolicy");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (policy));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp39_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp39_, NULL);
	g_variant_unref (_tmp39_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_op_policy (CupsPkHelper* self,
                                            const gchar* name,
                                            const gchar* policy,
                                            GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp40_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetOpPolicy");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (policy));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp40_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp40_, NULL);
	g_variant_unref (_tmp40_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_users_allowed (CupsPkHelper* self,
                                                const gchar* name,
                                                gchar** users,
                                                gint users_length1,
                                                GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp41_;
	GVariantBuilder _tmp42_;
	gint _tmp43_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp44_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetUsersAllowed");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_tmp41_ = users;
	g_variant_builder_init (&_tmp42_, G_VARIANT_TYPE ("as"));
	for (_tmp43_ = 0; _tmp43_ < users_length1; _tmp43_++) {
		g_variant_builder_add_value (&_tmp42_, g_variant_new_string (*_tmp41_));
		_tmp41_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp42_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp44_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp44_, NULL);
	g_variant_unref (_tmp44_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_set_users_denied (CupsPkHelper* self,
                                               const gchar* name,
                                               gchar** users,
                                               gint users_length1,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp45_;
	GVariantBuilder _tmp46_;
	gint _tmp47_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp48_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterSetUsersDenied");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_tmp45_ = users;
	g_variant_builder_init (&_tmp46_, G_VARIANT_TYPE ("as"));
	for (_tmp47_ = 0; _tmp47_ < users_length1; _tmp47_++) {
		g_variant_builder_add_value (&_tmp46_, g_variant_new_string (*_tmp45_));
		_tmp45_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp46_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp48_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp48_, NULL);
	g_variant_unref (_tmp48_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_add_option_default (CupsPkHelper* self,
                                                 const gchar* name,
                                                 const gchar* option,
                                                 gchar** values,
                                                 gint values_length1,
                                                 GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp49_;
	GVariantBuilder _tmp50_;
	gint _tmp51_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp52_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterAddOptionDefault");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (option));
	_tmp49_ = values;
	g_variant_builder_init (&_tmp50_, G_VARIANT_TYPE ("as"));
	for (_tmp51_ = 0; _tmp51_ < values_length1; _tmp51_++) {
		g_variant_builder_add_value (&_tmp50_, g_variant_new_string (*_tmp49_));
		_tmp49_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp50_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp52_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp52_, NULL);
	g_variant_unref (_tmp52_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_delete_option_default (CupsPkHelper* self,
                                                    const gchar* name,
                                                    const gchar* option,
                                                    GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp53_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterDeleteOptionDefault");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (option));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp53_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp53_, NULL);
	g_variant_unref (_tmp53_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_printer_add_option (CupsPkHelper* self,
                                         const gchar* name,
                                         const gchar* option,
                                         gchar** values,
                                         gint values_length1,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp54_;
	GVariantBuilder _tmp55_;
	gint _tmp56_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp57_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "PrinterAddOption");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (option));
	_tmp54_ = values;
	g_variant_builder_init (&_tmp55_, G_VARIANT_TYPE ("as"));
	for (_tmp56_ = 0; _tmp56_ < values_length1; _tmp56_++) {
		g_variant_builder_add_value (&_tmp55_, g_variant_new_string (*_tmp54_));
		_tmp54_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp55_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp57_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp57_, NULL);
	g_variant_unref (_tmp57_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_job_cancel_purge (CupsPkHelper* self,
                                       gint jobid,
                                       gboolean purge,
                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp58_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "JobCancelPurge");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (jobid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (purge));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp58_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp58_, NULL);
	g_variant_unref (_tmp58_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_job_restart (CupsPkHelper* self,
                                  gint jobid,
                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp59_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "JobRestart");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (jobid));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp59_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp59_, NULL);
	g_variant_unref (_tmp59_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
cups_pk_helper_proxy_job_set_hold_until (CupsPkHelper* self,
                                         gint jobid,
                                         const gchar* job_hold_until,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp60_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.opensuse.CupsPkHelper.Mechanism", "JobSetHoldUntil");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (jobid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (job_hold_until));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp60_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp60_, NULL);
	g_variant_unref (_tmp60_);
	g_object_unref (_reply_message);
	return _result;
}

static void
cups_pk_helper_proxy_cups_pk_helper_interface_init (CupsPkHelperIface* iface)
{
	iface->file_get = cups_pk_helper_proxy_file_get;
	iface->file_put = cups_pk_helper_proxy_file_put;
	iface->server_get_settings = cups_pk_helper_proxy_server_get_settings;
	iface->server_set_settings = cups_pk_helper_proxy_server_set_settings;
	iface->devices_get = cups_pk_helper_proxy_devices_get_async;
	iface->devices_get_finish = cups_pk_helper_proxy_devices_get_finish;
	iface->printer_add = cups_pk_helper_proxy_printer_add;
	iface->printer_add_with_ppd_file = cups_pk_helper_proxy_printer_add_with_ppd_file;
	iface->printer_set_device = cups_pk_helper_proxy_printer_set_device;
	iface->printer_set_default = cups_pk_helper_proxy_printer_set_default;
	iface->printer_set_enabled = cups_pk_helper_proxy_printer_set_enabled;
	iface->printer_set_accept_jobs = cups_pk_helper_proxy_printer_set_accept_jobs;
	iface->printer_delete = cups_pk_helper_proxy_printer_delete;
	iface->class_add_printer = cups_pk_helper_proxy_class_add_printer;
	iface->class_delete_printer = cups_pk_helper_proxy_class_delete_printer;
	iface->class_delete = cups_pk_helper_proxy_class_delete;
	iface->printer_set_info = cups_pk_helper_proxy_printer_set_info;
	iface->printer_set_location = cups_pk_helper_proxy_printer_set_location;
	iface->printer_set_shared = cups_pk_helper_proxy_printer_set_shared;
	iface->printer_set_job_sheets = cups_pk_helper_proxy_printer_set_job_sheets;
	iface->printer_set_error_policy = cups_pk_helper_proxy_printer_set_error_policy;
	iface->printer_set_op_policy = cups_pk_helper_proxy_printer_set_op_policy;
	iface->printer_set_users_allowed = cups_pk_helper_proxy_printer_set_users_allowed;
	iface->printer_set_users_denied = cups_pk_helper_proxy_printer_set_users_denied;
	iface->printer_add_option_default = cups_pk_helper_proxy_printer_add_option_default;
	iface->printer_delete_option_default = cups_pk_helper_proxy_printer_delete_option_default;
	iface->printer_add_option = cups_pk_helper_proxy_printer_add_option;
	iface->job_cancel_purge = cups_pk_helper_proxy_job_cancel_purge;
	iface->job_restart = cups_pk_helper_proxy_job_restart;
	iface->job_set_hold_until = cups_pk_helper_proxy_job_set_hold_until;
}

static void
_dbus_cups_pk_helper_file_get (CupsPkHelper* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* resource = NULL;
	GVariant* _tmp61_;
	gchar* filename = NULL;
	GVariant* _tmp62_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp61_ = g_variant_iter_next_value (&_arguments_iter);
	resource = g_variant_dup_string (_tmp61_, NULL);
	g_variant_unref (_tmp61_);
	_tmp62_ = g_variant_iter_next_value (&_arguments_iter);
	filename = g_variant_dup_string (_tmp62_, NULL);
	g_variant_unref (_tmp62_);
	result = cups_pk_helper_file_get (self, resource, filename, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (resource);
	_g_free0 (filename);
}

static void
_dbus_cups_pk_helper_file_put (CupsPkHelper* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* resource = NULL;
	GVariant* _tmp63_;
	gchar* filename = NULL;
	GVariant* _tmp64_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp63_ = g_variant_iter_next_value (&_arguments_iter);
	resource = g_variant_dup_string (_tmp63_, NULL);
	g_variant_unref (_tmp63_);
	_tmp64_ = g_variant_iter_next_value (&_arguments_iter);
	filename = g_variant_dup_string (_tmp64_, NULL);
	g_variant_unref (_tmp64_);
	result = cups_pk_helper_file_put (self, resource, filename, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (resource);
	_g_free0 (filename);
}

static void
_dbus_cups_pk_helper_server_get_settings (CupsPkHelper* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* _error_ = NULL;
	GHashTable* settings = NULL;
	GVariantBuilder _tmp65_;
	GHashTableIter _tmp66_;
	gpointer _tmp67_;
	gpointer _tmp68_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	cups_pk_helper_server_get_settings (self, &_error_, &settings, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (_error_));
	g_hash_table_iter_init (&_tmp66_, settings);
	g_variant_builder_init (&_tmp65_, G_VARIANT_TYPE ("a{ss}"));
	while (g_hash_table_iter_next (&_tmp66_, &_tmp67_, &_tmp68_)) {
		gchar* _key;
		gchar* _value;
		_key = (gchar*) _tmp67_;
		_value = (gchar*) _tmp68_;
		g_variant_builder_add (&_tmp65_, "{?*}", g_variant_new_string (_key), g_variant_new_string (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp65_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (_error_);
	_g_hash_table_unref0 (settings);
}

static void
_dbus_cups_pk_helper_server_set_settings (CupsPkHelper* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GHashTable* settings = NULL;
	GVariant* _tmp69_;
	GHashTable* _tmp70_;
	GVariantIter _tmp71_;
	GVariant* _tmp72_;
	GVariant* _tmp73_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp69_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp70_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
	g_variant_iter_init (&_tmp71_, _tmp69_);
	while (g_variant_iter_loop (&_tmp71_, "{?*}", &_tmp72_, &_tmp73_)) {
		g_hash_table_insert (_tmp70_, g_variant_dup_string (_tmp72_, NULL), g_variant_dup_string (_tmp73_, NULL));
	}
	settings = _tmp70_;
	g_variant_unref (_tmp69_);
	result = cups_pk_helper_server_set_settings (self, settings, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_hash_table_unref0 (settings);
}

static void
_dbus_cups_pk_helper_devices_get (CupsPkHelper* self,
                                  GVariant* _parameters_,
                                  GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	CupsPkHelperDevicesGetReadyData* _ready_data;
	GVariant* _tmp74_;
	GVariant* _tmp75_;
	GVariant* _tmp76_;
	gchar** _tmp77_;
	gint _tmp77__length;
	gint _tmp77__size;
	gint _tmp77__length1;
	GVariantIter _tmp78_;
	GVariant* _tmp79_;
	GVariant* _tmp80_;
	gchar** _tmp81_;
	gint _tmp81__length;
	gint _tmp81__size;
	gint _tmp81__length1;
	GVariantIter _tmp82_;
	GVariant* _tmp83_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (CupsPkHelperDevicesGetReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp74_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->timeout = g_variant_get_int32 (_tmp74_);
	g_variant_unref (_tmp74_);
	_tmp75_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->limit = g_variant_get_int32 (_tmp75_);
	g_variant_unref (_tmp75_);
	_tmp76_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp77_ = g_new (gchar*, 5);
	_tmp77__length = 0;
	_tmp77__size = 4;
	_tmp77__length1 = 0;
	g_variant_iter_init (&_tmp78_, _tmp76_);
	for (; (_tmp79_ = g_variant_iter_next_value (&_tmp78_)) != NULL; _tmp77__length1++) {
		if (_tmp77__size == _tmp77__length) {
			_tmp77__size = 2 * _tmp77__size;
			_tmp77_ = g_renew (gchar*, _tmp77_, _tmp77__size + 1);
		}
		_tmp77_[_tmp77__length++] = g_variant_dup_string (_tmp79_, NULL);
		g_variant_unref (_tmp79_);
	}
	_ready_data->include_schemes_length1 = _tmp77__length1;
	_tmp77_[_tmp77__length] = NULL;
	_ready_data->include_schemes = _tmp77_;
	g_variant_unref (_tmp76_);
	_tmp80_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp81_ = g_new (gchar*, 5);
	_tmp81__length = 0;
	_tmp81__size = 4;
	_tmp81__length1 = 0;
	g_variant_iter_init (&_tmp82_, _tmp80_);
	for (; (_tmp83_ = g_variant_iter_next_value (&_tmp82_)) != NULL; _tmp81__length1++) {
		if (_tmp81__size == _tmp81__length) {
			_tmp81__size = 2 * _tmp81__size;
			_tmp81_ = g_renew (gchar*, _tmp81_, _tmp81__size + 1);
		}
		_tmp81_[_tmp81__length++] = g_variant_dup_string (_tmp83_, NULL);
		g_variant_unref (_tmp83_);
	}
	_ready_data->exclude_schemes_length1 = _tmp81__length1;
	_tmp81_[_tmp81__length] = NULL;
	_ready_data->exclude_schemes = _tmp81_;
	g_variant_unref (_tmp80_);
	cups_pk_helper_devices_get (self, _ready_data->timeout, _ready_data->limit, _ready_data->include_schemes, _ready_data->include_schemes_length1, _ready_data->exclude_schemes, _ready_data->exclude_schemes_length1, (GAsyncReadyCallback) _dbus_cups_pk_helper_devices_get_ready, _ready_data);
}

static void
_dbus_cups_pk_helper_devices_get_ready (GObject * source_object,
                                        GAsyncResult * _res_,
                                        gpointer _user_data_)
{
	CupsPkHelperDevicesGetReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* _error_ = NULL;
	GHashTable* devices = NULL;
	GVariantBuilder _tmp84_;
	GHashTableIter _tmp85_;
	gpointer _tmp86_;
	gpointer _tmp87_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	cups_pk_helper_devices_get_finish ((CupsPkHelper*) source_object, _res_, &_error_, &devices, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (_error_));
	g_hash_table_iter_init (&_tmp85_, devices);
	g_variant_builder_init (&_tmp84_, G_VARIANT_TYPE ("a{ss}"));
	while (g_hash_table_iter_next (&_tmp85_, &_tmp86_, &_tmp87_)) {
		gchar* _key;
		gchar* _value;
		_key = (gchar*) _tmp86_;
		_value = (gchar*) _tmp87_;
		g_variant_builder_add (&_tmp84_, "{?*}", g_variant_new_string (_key), g_variant_new_string (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp84_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_ready_data->include_schemes = (_vala_array_free (_ready_data->include_schemes, _ready_data->include_schemes_length1, (GDestroyNotify) g_free), NULL);
	_ready_data->exclude_schemes = (_vala_array_free (_ready_data->exclude_schemes, _ready_data->exclude_schemes_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_error_);
	_g_hash_table_unref0 (devices);
	g_slice_free (CupsPkHelperDevicesGetReadyData, _ready_data);
}

static void
_dbus_cups_pk_helper_printer_add (CupsPkHelper* self,
                                  GVariant* _parameters_,
                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp88_;
	gchar* uri = NULL;
	GVariant* _tmp89_;
	gchar* ppd = NULL;
	GVariant* _tmp90_;
	gchar* info = NULL;
	GVariant* _tmp91_;
	gchar* location = NULL;
	GVariant* _tmp92_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp88_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp88_, NULL);
	g_variant_unref (_tmp88_);
	_tmp89_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp89_, NULL);
	g_variant_unref (_tmp89_);
	_tmp90_ = g_variant_iter_next_value (&_arguments_iter);
	ppd = g_variant_dup_string (_tmp90_, NULL);
	g_variant_unref (_tmp90_);
	_tmp91_ = g_variant_iter_next_value (&_arguments_iter);
	info = g_variant_dup_string (_tmp91_, NULL);
	g_variant_unref (_tmp91_);
	_tmp92_ = g_variant_iter_next_value (&_arguments_iter);
	location = g_variant_dup_string (_tmp92_, NULL);
	g_variant_unref (_tmp92_);
	result = cups_pk_helper_printer_add (self, name, uri, ppd, info, location, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (uri);
	_g_free0 (ppd);
	_g_free0 (info);
	_g_free0 (location);
}

static void
_dbus_cups_pk_helper_printer_add_with_ppd_file (CupsPkHelper* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp93_;
	gchar* uri = NULL;
	GVariant* _tmp94_;
	gchar* ppd = NULL;
	GVariant* _tmp95_;
	gchar* info = NULL;
	GVariant* _tmp96_;
	gchar* location = NULL;
	GVariant* _tmp97_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp93_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp93_, NULL);
	g_variant_unref (_tmp93_);
	_tmp94_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp94_, NULL);
	g_variant_unref (_tmp94_);
	_tmp95_ = g_variant_iter_next_value (&_arguments_iter);
	ppd = g_variant_dup_string (_tmp95_, NULL);
	g_variant_unref (_tmp95_);
	_tmp96_ = g_variant_iter_next_value (&_arguments_iter);
	info = g_variant_dup_string (_tmp96_, NULL);
	g_variant_unref (_tmp96_);
	_tmp97_ = g_variant_iter_next_value (&_arguments_iter);
	location = g_variant_dup_string (_tmp97_, NULL);
	g_variant_unref (_tmp97_);
	result = cups_pk_helper_printer_add_with_ppd_file (self, name, uri, ppd, info, location, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (uri);
	_g_free0 (ppd);
	_g_free0 (info);
	_g_free0 (location);
}

static void
_dbus_cups_pk_helper_printer_set_device (CupsPkHelper* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp98_;
	gchar* device = NULL;
	GVariant* _tmp99_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp98_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp98_, NULL);
	g_variant_unref (_tmp98_);
	_tmp99_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp99_, NULL);
	g_variant_unref (_tmp99_);
	result = cups_pk_helper_printer_set_device (self, name, device, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (device);
}

static void
_dbus_cups_pk_helper_printer_set_default (CupsPkHelper* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp100_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp100_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp100_, NULL);
	g_variant_unref (_tmp100_);
	result = cups_pk_helper_printer_set_default (self, name, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
}

static void
_dbus_cups_pk_helper_printer_set_enabled (CupsPkHelper* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp101_;
	gboolean enabled = FALSE;
	GVariant* _tmp102_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp101_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp101_, NULL);
	g_variant_unref (_tmp101_);
	_tmp102_ = g_variant_iter_next_value (&_arguments_iter);
	enabled = g_variant_get_boolean (_tmp102_);
	g_variant_unref (_tmp102_);
	result = cups_pk_helper_printer_set_enabled (self, name, enabled, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
}

static void
_dbus_cups_pk_helper_printer_set_accept_jobs (CupsPkHelper* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp103_;
	gboolean enabled = FALSE;
	GVariant* _tmp104_;
	gchar* reason = NULL;
	GVariant* _tmp105_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp103_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp103_, NULL);
	g_variant_unref (_tmp103_);
	_tmp104_ = g_variant_iter_next_value (&_arguments_iter);
	enabled = g_variant_get_boolean (_tmp104_);
	g_variant_unref (_tmp104_);
	_tmp105_ = g_variant_iter_next_value (&_arguments_iter);
	reason = g_variant_dup_string (_tmp105_, NULL);
	g_variant_unref (_tmp105_);
	result = cups_pk_helper_printer_set_accept_jobs (self, name, enabled, reason, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (reason);
}

static void
_dbus_cups_pk_helper_printer_delete (CupsPkHelper* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp106_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp106_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp106_, NULL);
	g_variant_unref (_tmp106_);
	result = cups_pk_helper_printer_delete (self, name, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
}

static void
_dbus_cups_pk_helper_class_add_printer (CupsPkHelper* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp107_;
	gchar* printer = NULL;
	GVariant* _tmp108_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp107_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp107_, NULL);
	g_variant_unref (_tmp107_);
	_tmp108_ = g_variant_iter_next_value (&_arguments_iter);
	printer = g_variant_dup_string (_tmp108_, NULL);
	g_variant_unref (_tmp108_);
	result = cups_pk_helper_class_add_printer (self, name, printer, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (printer);
}

static void
_dbus_cups_pk_helper_class_delete_printer (CupsPkHelper* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp109_;
	gchar* printer = NULL;
	GVariant* _tmp110_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp109_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp109_, NULL);
	g_variant_unref (_tmp109_);
	_tmp110_ = g_variant_iter_next_value (&_arguments_iter);
	printer = g_variant_dup_string (_tmp110_, NULL);
	g_variant_unref (_tmp110_);
	result = cups_pk_helper_class_delete_printer (self, name, printer, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (printer);
}

static void
_dbus_cups_pk_helper_class_delete (CupsPkHelper* self,
                                   GVariant* _parameters_,
                                   GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp111_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp111_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp111_, NULL);
	g_variant_unref (_tmp111_);
	result = cups_pk_helper_class_delete (self, name, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
}

static void
_dbus_cups_pk_helper_printer_set_info (CupsPkHelper* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp112_;
	gchar* info = NULL;
	GVariant* _tmp113_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp112_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp112_, NULL);
	g_variant_unref (_tmp112_);
	_tmp113_ = g_variant_iter_next_value (&_arguments_iter);
	info = g_variant_dup_string (_tmp113_, NULL);
	g_variant_unref (_tmp113_);
	result = cups_pk_helper_printer_set_info (self, name, info, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (info);
}

static void
_dbus_cups_pk_helper_printer_set_location (CupsPkHelper* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp114_;
	gchar* location = NULL;
	GVariant* _tmp115_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp114_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp114_, NULL);
	g_variant_unref (_tmp114_);
	_tmp115_ = g_variant_iter_next_value (&_arguments_iter);
	location = g_variant_dup_string (_tmp115_, NULL);
	g_variant_unref (_tmp115_);
	result = cups_pk_helper_printer_set_location (self, name, location, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (location);
}

static void
_dbus_cups_pk_helper_printer_set_shared (CupsPkHelper* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp116_;
	gboolean shared = FALSE;
	GVariant* _tmp117_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp116_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp116_, NULL);
	g_variant_unref (_tmp116_);
	_tmp117_ = g_variant_iter_next_value (&_arguments_iter);
	shared = g_variant_get_boolean (_tmp117_);
	g_variant_unref (_tmp117_);
	result = cups_pk_helper_printer_set_shared (self, name, shared, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
}

static void
_dbus_cups_pk_helper_printer_set_job_sheets (CupsPkHelper* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp118_;
	gchar* start = NULL;
	GVariant* _tmp119_;
	gchar* end = NULL;
	GVariant* _tmp120_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp118_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp118_, NULL);
	g_variant_unref (_tmp118_);
	_tmp119_ = g_variant_iter_next_value (&_arguments_iter);
	start = g_variant_dup_string (_tmp119_, NULL);
	g_variant_unref (_tmp119_);
	_tmp120_ = g_variant_iter_next_value (&_arguments_iter);
	end = g_variant_dup_string (_tmp120_, NULL);
	g_variant_unref (_tmp120_);
	result = cups_pk_helper_printer_set_job_sheets (self, name, start, end, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (start);
	_g_free0 (end);
}

static void
_dbus_cups_pk_helper_printer_set_error_policy (CupsPkHelper* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp121_;
	gchar* policy = NULL;
	GVariant* _tmp122_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp121_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp121_, NULL);
	g_variant_unref (_tmp121_);
	_tmp122_ = g_variant_iter_next_value (&_arguments_iter);
	policy = g_variant_dup_string (_tmp122_, NULL);
	g_variant_unref (_tmp122_);
	result = cups_pk_helper_printer_set_error_policy (self, name, policy, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (policy);
}

static void
_dbus_cups_pk_helper_printer_set_op_policy (CupsPkHelper* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp123_;
	gchar* policy = NULL;
	GVariant* _tmp124_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp123_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp123_, NULL);
	g_variant_unref (_tmp123_);
	_tmp124_ = g_variant_iter_next_value (&_arguments_iter);
	policy = g_variant_dup_string (_tmp124_, NULL);
	g_variant_unref (_tmp124_);
	result = cups_pk_helper_printer_set_op_policy (self, name, policy, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (policy);
}

static void
_dbus_cups_pk_helper_printer_set_users_allowed (CupsPkHelper* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp125_;
	gchar** users = NULL;
	gint users_length1 = 0;
	GVariant* _tmp126_;
	gchar** _tmp127_;
	gint _tmp127__length;
	gint _tmp127__size;
	gint _tmp127__length1;
	GVariantIter _tmp128_;
	GVariant* _tmp129_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp125_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp125_, NULL);
	g_variant_unref (_tmp125_);
	_tmp126_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp127_ = g_new (gchar*, 5);
	_tmp127__length = 0;
	_tmp127__size = 4;
	_tmp127__length1 = 0;
	g_variant_iter_init (&_tmp128_, _tmp126_);
	for (; (_tmp129_ = g_variant_iter_next_value (&_tmp128_)) != NULL; _tmp127__length1++) {
		if (_tmp127__size == _tmp127__length) {
			_tmp127__size = 2 * _tmp127__size;
			_tmp127_ = g_renew (gchar*, _tmp127_, _tmp127__size + 1);
		}
		_tmp127_[_tmp127__length++] = g_variant_dup_string (_tmp129_, NULL);
		g_variant_unref (_tmp129_);
	}
	users_length1 = _tmp127__length1;
	_tmp127_[_tmp127__length] = NULL;
	users = _tmp127_;
	g_variant_unref (_tmp126_);
	result = cups_pk_helper_printer_set_users_allowed (self, name, users, users_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	users = (_vala_array_free (users, users_length1, (GDestroyNotify) g_free), NULL);
}

static void
_dbus_cups_pk_helper_printer_set_users_denied (CupsPkHelper* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp130_;
	gchar** users = NULL;
	gint users_length1 = 0;
	GVariant* _tmp131_;
	gchar** _tmp132_;
	gint _tmp132__length;
	gint _tmp132__size;
	gint _tmp132__length1;
	GVariantIter _tmp133_;
	GVariant* _tmp134_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp130_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp130_, NULL);
	g_variant_unref (_tmp130_);
	_tmp131_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp132_ = g_new (gchar*, 5);
	_tmp132__length = 0;
	_tmp132__size = 4;
	_tmp132__length1 = 0;
	g_variant_iter_init (&_tmp133_, _tmp131_);
	for (; (_tmp134_ = g_variant_iter_next_value (&_tmp133_)) != NULL; _tmp132__length1++) {
		if (_tmp132__size == _tmp132__length) {
			_tmp132__size = 2 * _tmp132__size;
			_tmp132_ = g_renew (gchar*, _tmp132_, _tmp132__size + 1);
		}
		_tmp132_[_tmp132__length++] = g_variant_dup_string (_tmp134_, NULL);
		g_variant_unref (_tmp134_);
	}
	users_length1 = _tmp132__length1;
	_tmp132_[_tmp132__length] = NULL;
	users = _tmp132_;
	g_variant_unref (_tmp131_);
	result = cups_pk_helper_printer_set_users_denied (self, name, users, users_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	users = (_vala_array_free (users, users_length1, (GDestroyNotify) g_free), NULL);
}

static void
_dbus_cups_pk_helper_printer_add_option_default (CupsPkHelper* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp135_;
	gchar* option = NULL;
	GVariant* _tmp136_;
	gchar** values = NULL;
	gint values_length1 = 0;
	GVariant* _tmp137_;
	gchar** _tmp138_;
	gint _tmp138__length;
	gint _tmp138__size;
	gint _tmp138__length1;
	GVariantIter _tmp139_;
	GVariant* _tmp140_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp135_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp135_, NULL);
	g_variant_unref (_tmp135_);
	_tmp136_ = g_variant_iter_next_value (&_arguments_iter);
	option = g_variant_dup_string (_tmp136_, NULL);
	g_variant_unref (_tmp136_);
	_tmp137_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp138_ = g_new (gchar*, 5);
	_tmp138__length = 0;
	_tmp138__size = 4;
	_tmp138__length1 = 0;
	g_variant_iter_init (&_tmp139_, _tmp137_);
	for (; (_tmp140_ = g_variant_iter_next_value (&_tmp139_)) != NULL; _tmp138__length1++) {
		if (_tmp138__size == _tmp138__length) {
			_tmp138__size = 2 * _tmp138__size;
			_tmp138_ = g_renew (gchar*, _tmp138_, _tmp138__size + 1);
		}
		_tmp138_[_tmp138__length++] = g_variant_dup_string (_tmp140_, NULL);
		g_variant_unref (_tmp140_);
	}
	values_length1 = _tmp138__length1;
	_tmp138_[_tmp138__length] = NULL;
	values = _tmp138_;
	g_variant_unref (_tmp137_);
	result = cups_pk_helper_printer_add_option_default (self, name, option, values, values_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (option);
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
}

static void
_dbus_cups_pk_helper_printer_delete_option_default (CupsPkHelper* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp141_;
	gchar* option = NULL;
	GVariant* _tmp142_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp141_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp141_, NULL);
	g_variant_unref (_tmp141_);
	_tmp142_ = g_variant_iter_next_value (&_arguments_iter);
	option = g_variant_dup_string (_tmp142_, NULL);
	g_variant_unref (_tmp142_);
	result = cups_pk_helper_printer_delete_option_default (self, name, option, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (option);
}

static void
_dbus_cups_pk_helper_printer_add_option (CupsPkHelper* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp143_;
	gchar* option = NULL;
	GVariant* _tmp144_;
	gchar** values = NULL;
	gint values_length1 = 0;
	GVariant* _tmp145_;
	gchar** _tmp146_;
	gint _tmp146__length;
	gint _tmp146__size;
	gint _tmp146__length1;
	GVariantIter _tmp147_;
	GVariant* _tmp148_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp143_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp143_, NULL);
	g_variant_unref (_tmp143_);
	_tmp144_ = g_variant_iter_next_value (&_arguments_iter);
	option = g_variant_dup_string (_tmp144_, NULL);
	g_variant_unref (_tmp144_);
	_tmp145_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp146_ = g_new (gchar*, 5);
	_tmp146__length = 0;
	_tmp146__size = 4;
	_tmp146__length1 = 0;
	g_variant_iter_init (&_tmp147_, _tmp145_);
	for (; (_tmp148_ = g_variant_iter_next_value (&_tmp147_)) != NULL; _tmp146__length1++) {
		if (_tmp146__size == _tmp146__length) {
			_tmp146__size = 2 * _tmp146__size;
			_tmp146_ = g_renew (gchar*, _tmp146_, _tmp146__size + 1);
		}
		_tmp146_[_tmp146__length++] = g_variant_dup_string (_tmp148_, NULL);
		g_variant_unref (_tmp148_);
	}
	values_length1 = _tmp146__length1;
	_tmp146_[_tmp146__length] = NULL;
	values = _tmp146_;
	g_variant_unref (_tmp145_);
	result = cups_pk_helper_printer_add_option (self, name, option, values, values_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
	_g_free0 (option);
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
}

static void
_dbus_cups_pk_helper_job_cancel_purge (CupsPkHelper* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint jobid = 0;
	GVariant* _tmp149_;
	gboolean purge = FALSE;
	GVariant* _tmp150_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp149_ = g_variant_iter_next_value (&_arguments_iter);
	jobid = g_variant_get_int32 (_tmp149_);
	g_variant_unref (_tmp149_);
	_tmp150_ = g_variant_iter_next_value (&_arguments_iter);
	purge = g_variant_get_boolean (_tmp150_);
	g_variant_unref (_tmp150_);
	result = cups_pk_helper_job_cancel_purge (self, jobid, purge, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_cups_pk_helper_job_restart (CupsPkHelper* self,
                                  GVariant* _parameters_,
                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint jobid = 0;
	GVariant* _tmp151_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp151_ = g_variant_iter_next_value (&_arguments_iter);
	jobid = g_variant_get_int32 (_tmp151_);
	g_variant_unref (_tmp151_);
	result = cups_pk_helper_job_restart (self, jobid, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_cups_pk_helper_job_set_hold_until (CupsPkHelper* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint jobid = 0;
	GVariant* _tmp152_;
	gchar* job_hold_until = NULL;
	GVariant* _tmp153_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp152_ = g_variant_iter_next_value (&_arguments_iter);
	jobid = g_variant_get_int32 (_tmp152_);
	g_variant_unref (_tmp152_);
	_tmp153_ = g_variant_iter_next_value (&_arguments_iter);
	job_hold_until = g_variant_dup_string (_tmp153_, NULL);
	g_variant_unref (_tmp153_);
	result = cups_pk_helper_job_set_hold_until (self, jobid, job_hold_until, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (job_hold_until);
}

static void
cups_pk_helper_dbus_interface_method_call (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* method_name,
                                           GVariant* parameters,
                                           GDBusMethodInvocation* invocation,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "FileGet") == 0) {
		_dbus_cups_pk_helper_file_get (object, parameters, invocation);
	} else if (strcmp (method_name, "FilePut") == 0) {
		_dbus_cups_pk_helper_file_put (object, parameters, invocation);
	} else if (strcmp (method_name, "ServerGetSettings") == 0) {
		_dbus_cups_pk_helper_server_get_settings (object, parameters, invocation);
	} else if (strcmp (method_name, "ServerSetSettings") == 0) {
		_dbus_cups_pk_helper_server_set_settings (object, parameters, invocation);
	} else if (strcmp (method_name, "DevicesGet") == 0) {
		_dbus_cups_pk_helper_devices_get (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterAdd") == 0) {
		_dbus_cups_pk_helper_printer_add (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterAddWithPpdFile") == 0) {
		_dbus_cups_pk_helper_printer_add_with_ppd_file (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetDevice") == 0) {
		_dbus_cups_pk_helper_printer_set_device (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetDefault") == 0) {
		_dbus_cups_pk_helper_printer_set_default (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetEnabled") == 0) {
		_dbus_cups_pk_helper_printer_set_enabled (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetAcceptJobs") == 0) {
		_dbus_cups_pk_helper_printer_set_accept_jobs (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterDelete") == 0) {
		_dbus_cups_pk_helper_printer_delete (object, parameters, invocation);
	} else if (strcmp (method_name, "ClassAddPrinter") == 0) {
		_dbus_cups_pk_helper_class_add_printer (object, parameters, invocation);
	} else if (strcmp (method_name, "ClassDeletePrinter") == 0) {
		_dbus_cups_pk_helper_class_delete_printer (object, parameters, invocation);
	} else if (strcmp (method_name, "ClassDelete") == 0) {
		_dbus_cups_pk_helper_class_delete (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetInfo") == 0) {
		_dbus_cups_pk_helper_printer_set_info (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetLocation") == 0) {
		_dbus_cups_pk_helper_printer_set_location (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetShared") == 0) {
		_dbus_cups_pk_helper_printer_set_shared (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetJobSheets") == 0) {
		_dbus_cups_pk_helper_printer_set_job_sheets (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetErrorPolicy") == 0) {
		_dbus_cups_pk_helper_printer_set_error_policy (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetOpPolicy") == 0) {
		_dbus_cups_pk_helper_printer_set_op_policy (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetUsersAllowed") == 0) {
		_dbus_cups_pk_helper_printer_set_users_allowed (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterSetUsersDenied") == 0) {
		_dbus_cups_pk_helper_printer_set_users_denied (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterAddOptionDefault") == 0) {
		_dbus_cups_pk_helper_printer_add_option_default (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterDeleteOptionDefault") == 0) {
		_dbus_cups_pk_helper_printer_delete_option_default (object, parameters, invocation);
	} else if (strcmp (method_name, "PrinterAddOption") == 0) {
		_dbus_cups_pk_helper_printer_add_option (object, parameters, invocation);
	} else if (strcmp (method_name, "JobCancelPurge") == 0) {
		_dbus_cups_pk_helper_job_cancel_purge (object, parameters, invocation);
	} else if (strcmp (method_name, "JobRestart") == 0) {
		_dbus_cups_pk_helper_job_restart (object, parameters, invocation);
	} else if (strcmp (method_name, "JobSetHoldUntil") == 0) {
		_dbus_cups_pk_helper_job_set_hold_until (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
cups_pk_helper_dbus_interface_get_property (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* property_name,
                                            GError** error,
                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
cups_pk_helper_dbus_interface_set_property (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* property_name,
                                            GVariant* value,
                                            GError** error,
                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
cups_pk_helper_register_object (gpointer object,
                                GDBusConnection* connection,
                                const gchar* path,
                                GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_cups_pk_helper_dbus_interface_info), &_cups_pk_helper_dbus_interface_vtable, data, _cups_pk_helper_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_cups_pk_helper_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

CupsPkHelper*
cups_get_pk_helper (void)
{
	CupsPkHelper* _tmp0_;
	CupsPkHelper* _tmp6_;
	GError* _inner_error0_ = NULL;
	CupsPkHelper* result = NULL;
	_tmp0_ = cups_pk_helper;
	if (_tmp0_ == NULL) {
		{
			CupsPkHelper* _tmp1_ = NULL;
			CupsPkHelper* _tmp2_;
			CupsPkHelper* _tmp3_;
			_tmp2_ = (CupsPkHelper*) g_initable_new (CUPS_TYPE_PK_HELPER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.opensuse.CupsPkHelper.Mechanism", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/", "g-interface-name", "org.opensuse.CupsPkHelper.Mechanism", "g-interface-info", g_type_get_qdata (CUPS_TYPE_PK_HELPER, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
			_tmp1_ = (CupsPkHelper*) _tmp2_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_IO_ERROR) {
					goto __catch0_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
			_tmp3_ = _tmp1_;
			_tmp1_ = NULL;
			_g_object_unref0 (cups_pk_helper);
			cups_pk_helper = _tmp3_;
			_g_object_unref0 (_tmp1_);
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp4_ = e;
			_tmp5_ = _tmp4_->message;
			g_critical ("CUPSPkHelper.vala:67: %s", _tmp5_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp6_ = cups_pk_helper;
	result = _tmp6_;
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

